@cd /d "%~dp0"

chcp 1251

set OPENSSL_PATH=D:\OpenSSL\Win64\bin
set PATH=%OPENSSL_PATH%
set OPENSSL_CONF=%OPENSSL_PATH%\openssl.cfg

set RANDFILE=.rnd

set RSA=2048
set DH=2048
set days=358669
set C=RU
set ST=RUSSIA
set L=VLADIMIR
set O=MAALCHEMIST
set OU=SKYDSUITE-HTTP
set CN=SKYDSUITE-HTTP.MAALCHEMIST.RU
set E=skydsuite-http@maalchemist.ru
set key=skyDSuite_HTTP.key
set csr=skyDSuite_HTTP.csr
set crt=skyDSuite_HTTP.crt
set p12=skyDSuite_HTTP.p12
set dhp=skyDSuite_HTTP.dhp
set cnf=skyDSuite_HTTP.cnf
set CA_crt=skyDSuite_CA.crt
set CA_key=skyDSuite_CA.key

set subj=/C="%C%"/ST="%ST%"/L="%L%"/O="%O%"/OU="%OU%"/CN="%CN%"/emailAddress=%E%

@ECHO OFF
IF EXIST %key% DEL %key%
IF EXIST %csr% DEL %csr%
IF EXIST %crt% DEL %crt%
IF EXIST %p12% DEL %p12%
IF EXIST %dhp% DEL %dhp%
@ECHO ON

rem  
    openssl genrsa -out %key% %RSA%
rem    
    openssl req -new -subj %subj% -key %key% -out %csr% -extensions v3_req -config %cnf%
rem    
    openssl req -text -noout -in %csr%

rem       
    openssl x509 -req -in %csr% -CA %CA_crt% -CAkey %CA_key% -CAcreateserial -days %days% -out %crt% -extensions v3_req -extfile %cnf%

rem          PKCS12
rem openssl pkcs12 -export -in %crt% -inkey %key% -password pass: -out %p12%

rem  DH 
    openssl dhparam -out %dhp% %DH%

pause
